-- Ŀ
--  Space Invaders - The Next Generation - V1.04                  Library #1 
-- 

include file.e
include graphics.e
include delay.e
include doswrap.e
include soundfx.e

DmaChannel = DMA8 -- only play 8 bit sound.

global sequence SoundEffects -- contain parameter for each sound effect.
-- needed parameters: {buffer,Size,TimeConstant, channels}
global integer  SoundEfx          SoundEfx = 0
global integer  Score,LastScore   Score = 0 LastScore = 0
global integer  Wave              Wave = 0
global integer  LaserCharge       LaserCharge = 0
global integer  LaserMaxChg       LaserMaxChg = 0

global integer  RoutineCnt1       RoutineCnt1 = 0
global integer  RoutineCnt2       RoutineCnt2 = 0
global integer  ShipX             ShipX = 160
global integer  ShipLx            ShipLx = 160
global integer  ShipY             ShipY = 199
global integer  ShipShield        ShipShield = 0

global sequence  PixelAlloc       PixelAlloc = repeat(0,255)

-- Sprite characteristics
global integer  AttentionX        AttentionX = 160
global integer  AttentionY        AttentionY = 100
global integer  Attention         Attention = 0 -- 0 = None
global integer  GroupFear         GroupFear  = 0 -- 0 = None

global sequence SpriteX           SpriteX = repeat(160,100)
global sequence SpriteY           SpriteY = repeat(100,100)
global sequence SpriteXd          SpriteXd = repeat(160,100)
global sequence SpriteYd          SpriteYd = repeat(100,100)
global sequence SpriteShape       SpriteShape = repeat({},100)
global sequence SpriteType        SpriteType = repeat(0,100)
global sequence SpriteFear        SpriteFear = repeat(0,100)

global integer  Sprite            Sprite = 0 -- Current sprite
global integer  Sprites           Sprites = 0 -- Sprite count
global integer  SpritesAdvance    SpritesAdvance = 0

global integer  SpriteHit -- Index of last sprite hit
global integer  SpritesActive     SpritesActive = 0
global integer  FiringLine        FiringLine = 0 -- No shooting above this line

global sequence ExplosionColours  ExplosionColours = {15,14,12,10}
global integer  ParticleMax       ParticleMax = 0
global integer  ParticleTrail     ParticleTrail = 0
global integer  ParticleCount     ParticleCount = 50
global integer  ParticleRadius    ParticleRadius = 10
global atom     ParticleGravity   ParticleGravity = 0
global atom     ParticleXBias     ParticleXBias = 0
global atom     ParticleYBias     ParticleYBias = 0
sequence        ParticleX         ParticleX = {}
sequence        ParticleY         ParticleY = {}
sequence        ParticleXi        ParticleXi = {}
sequence        ParticleYi        ParticleYi = {}
sequence        ParticleS         ParticleS = {}
sequence        ParticleR         ParticleR = {}
sequence        ParticleC         ParticleC = {}

global integer  MissileTrail      MissileTrail = 0
global integer  MissileMax        MissileMax = 0
sequence        MissileX          MissileX = {}
sequence        MissileY          MissileY = {}
sequence        MissileXi         MissileXi = {}
sequence        MissileYi         MissileYi = {}
sequence        MissileC          MissileC = {}

global integer GfxLft,GfxRht,GfxTop,GfxBot

GfxLft = 0
GfxRht = 319
GfxTop = 0
GfxBot = 199

global function MoveTo(integer xy1,integer xy2,integer ofset)
  if xy1 < xy2 then
    return xy1 + ofset
  elsif xy1 > xy2 then
    return xy1 - ofset
  else
    return xy1
  end if
end function

global function MoveAwayX(integer x1,integer x2,integer ofset)
  integer x
  x = x1
  if x1 > x2 then
    if x1 < GfxRht then
      x = x1 + ofset
    end if
  elsif x1 < x2 then
    if x1 > GfxLft then
      x = x1 - ofset
    end if
  end if
  return x
end function

global function MoveAwayY(integer y1,integer y2,integer ofset)
  integer y
  y = y1
  if y1 > y2 then
    if y1 < GfxBot then
      y = y1 + ofset
    end if
  elsif y1 < y2 then
    if y1 > GfxTop then
      y = y1 - ofset
    end if
  end if
  return y
end function

global procedure HouseKeeping(integer id)
  if iSbCardError = 0 then -- SB Card is OK
    if SoundEfx > 0 then
      PlaySoundEffect(SoundEffects[SoundEfx]) 
      SoundEfx = 0
    end if
  end if
  
  if Attention > 0 then
    Attention = Attention - rand(3)
  end if
  
  if GroupFear > 0 then
    GroupFear = GroupFear - rand(2)
  end if
  
  if LaserCharge < LaserMaxChg then
    LaserCharge = LaserCharge + 1
  end if  
end procedure

global function InstallSprite(integer id,sequence shape)
  integer bc,p,l,ofc
  bc = 15 + ((id - 1) * 4)
  
  PixelAlloc[bc + 1] = id
  PixelAlloc[bc + 2] = id
  PixelAlloc[bc + 3] = id
  PixelAlloc[bc + 4] = id
  
  for idx = 1 to length(shape) do
    l = length(shape[idx])
    for x = 3 to l do
      p = shape[idx][x]
      if p > 0 then
	shape[idx][x] = p + bc
      end if
    end for
  end for 
  return shape
end function

global procedure UpdateSprite(integer id)
  integer sx,sy,x,y,l,st
  sequence c,shape
  
  st = SpriteType[id]
  
  if id = 1 then
    SpritesActive = RoutineCnt2 -- Establish live sprites
    FiringLine = RoutineCnt1 -- Establish firing line
    RoutineCnt1 = 0
    RoutineCnt2 = 0
  end if
  if st > 0 then
    sx = SpriteX[id]
    sy = SpriteY[id]
    if sy > RoutineCnt1 then
      RoutineCnt1 = sy
    end if
    shape = SpriteShape[id]
    for idx = 1 to length(shape) do
      l = length(shape[idx])
      y = shape[idx][1]
      x = shape[idx][2]
      c = shape[idx][3..l]
      pixel(c,{sx - x, sy + y})
    end for
    RoutineCnt2 = RoutineCnt2 + 1
  end if
end procedure

global procedure NewMissile(integer x,integer y,atom xi,atom yi,integer colour)
  SoundEfx = 1
  MissileMax = MissileMax + 1
  if MissileMax > length(MissileX) then -- Expand list
    MissileX =  MissileX  & repeat(0,50)
    MissileY =  MissileY  & repeat(0,50)
    MissileXi = MissileXi & repeat(0,50)
    MissileYi = MissileYi & repeat(0,50)
    MissileC =  MissileC  & repeat(0,50)
  end if
  MissileX[MissileMax] = x
  MissileY[MissileMax] = y
  MissileXi[MissileMax] = xi
  MissileYi[MissileMax] = yi
  MissileC[MissileMax] = colour
end procedure

global procedure NewExplosion(integer x,integer y,integer n,integer m,integer e)
  atom angle,radius,xi,yi
  SoundEfx = e 
  for cnt = 1 to n do
    ParticleMax = ParticleMax + 1
    if ParticleMax > length(ParticleX) then -- Expand list
      ParticleX  = ParticleX  & repeat(0,100)
      ParticleY  = ParticleY  & repeat(0,100)
      ParticleXi = ParticleXi & repeat(0,100)
      ParticleYi = ParticleYi & repeat(0,100)
      ParticleS  = ParticleS  & repeat(0,100)
      ParticleR  = ParticleR  & repeat(0,100)
      ParticleC  = ParticleC  & repeat(0,100)
    end if
    ParticleX[ParticleMax] = x
    ParticleY[ParticleMax] = y
    xi = 0
    yi = 0
    while (xi = 0) and (yi = 0) do
      angle = (rand(314159 * 2) / 10000)
      radius = 1 + (rand(2000) / 1000)
      xi = ParticleXBias + (sin(angle) * radius)
      yi = ParticleYBias + (cos(angle) * radius)
    end while
    ParticleXi[ParticleMax] = xi
    ParticleYi[ParticleMax] = yi
    ParticleS[ParticleMax] = 1
    ParticleR[ParticleMax] = m + rand(m)
    ParticleC[ParticleMax] = ExplosionColours[rand(length(ExplosionColours))]
  end for
end procedure

global procedure UpdateMissiles()
  integer c,kill,pix
  atom x,y
  if MissileMax > 0 then
    for p = 1 to MissileMax do
      x = MissileX[p]
      y = MissileY[p]
      draw_line(0,{{x - 1,y},{x + 1,y}})
      draw_line(0,{{x,y - 1},{x,y + 1}})
      x = x + MissileXi[p]
      y = y + MissileYi[p]
      if x < GfxLft then
	kill = 1
      elsif x > GfxRht then
	kill = 1
      elsif y < GfxTop then
	kill = 1
      elsif y > GfxBot then
	kill = 1
      else
	kill = 0
      end if
      
      --pix = get_pixel({x,y})
      pix = machine_func(21,{x,y})
      if pix > 7 then -- Something hit
	if pix > 15 then -- Sprite hit
	  SpriteHit = PixelAlloc[pix]
	  if SpriteHit > 0 then
	    if SpriteType[SpriteHit] > 0 then -- Sprite "was" alive
	      NewExplosion(floor(x),floor(y),ParticleCount,ParticleRadius,2)
	      Score = Score + (SpriteType[SpriteHit] + Wave) * 10
	      SpriteType[SpriteHit] = 0
	      AttentionX = floor(x)
	      AttentionY = floor(y)
	      Attention = 250
	      GroupFear = GroupFear + 100
	      kill = 2
	      SpriteHit = 0
	    end if
	  end if
	else -- pix <= 15 - Ship hit
	  ShipShield = ShipShield - 1
	  if ShipShield < 1 then -- Ship is dead
	    NewExplosion(floor(x),floor(y),250,50,2)
	  else -- Ricochet !
	    NewExplosion(floor(x),floor(y),25,10,3)
	  end if
	  GroupFear = GroupFear - 1000
	  kill = 3
	end if
      end if
      
      if kill > 0 then -- Kill missile
	MissileX[p]  = MissileX[MissileMax]
	MissileY[p]  = MissileY[MissileMax]
	MissileXi[p] = MissileXi[MissileMax]
	MissileYi[p] = MissileYi[MissileMax]
	MissileC[p]  = MissileC[MissileMax]
	MissileMax = MissileMax - 1
      else -- Update missile
	c = MissileC[p]
	draw_line(c,{{x - 1,y},{x + 1,y}})
	draw_line(c,{{x,y - 1},{x,y + 1}})
	MissileX[p] = x
	MissileY[p] = y
      end if
    end for
  end if
end procedure

procedure KillParticle(integer e)
  pixel(0,{ParticleX[e],ParticleY[e]})
  ParticleX[e] = ParticleX[ParticleMax]
  ParticleY[e] = ParticleY[ParticleMax]
  ParticleXi[e] = ParticleXi[ParticleMax]
  ParticleYi[e] = ParticleYi[ParticleMax]
  ParticleS[e] = ParticleS[ParticleMax]
  ParticleR[e] = ParticleR[ParticleMax]
  ParticleC[e] = ParticleC[ParticleMax]
  ParticleMax = ParticleMax - 1
end procedure

global procedure UpdateExplosions()
  integer s,m,c
  atom x,y
  if ParticleMax > 0 then
    for e = 1 to ParticleMax do
      x = ParticleX[e]
      y = ParticleY[e]
      s = ParticleS[e]
      m = ParticleR[e]
      machine_proc(4,{0,{x,y}}) -- M_PIXEL
      if ParticleGravity != 0 then
	ParticleYi[e] = ParticleYi[e] + ParticleGravity
      end if
      x = x + ParticleXi[e]
      y = y + ParticleYi[e]
      if x < GfxLft then s = m end if
      if x > GfxRht then s = m end if
      if y < GfxTop then s = m  end if
      if y > GfxBot then s = m end if
      s = s + 1
      if s > m then -- Kill particle
	machine_proc(4,{0,{x,y}}) -- M_PIXEL
	KillParticle(e)
      else -- Update particle
	c = ParticleC[e]
	machine_proc(4,{c,{x,y}}) -- M_PIXEL
	ParticleX[e] = x
	ParticleY[e] = y
	ParticleS[e] = s
      end if
    end for
  end if
end procedure

-- Abs (2=2, 1=1, 0=0, -1=1, -2=2)
global function Abs(object n)
  if n < 0 then
    return -n
  else
    return n
  end if
end function
-- Sign (2=1, 1=1, 0=0, -1=-1, -2=-1)
global function Sign(object n)
  if n > 0 then
    return 1
  elsif n < 0 then
    return -1
  else
    return 0
  end if
end function

