-- Ŀ
--  Space Invaders - The Next Generation - V1.04                  Library #2 
-- 

global sequence Palette Palette = repeat({0,0,0},256)
global sequence Shapes,Shape

global sequence InvaderBlink      InvaderBlink = repeat(0,100)
global sequence InvaderEyeX       InvaderEyeX  = repeat(0,100)
global sequence InvaderEyeY       InvaderEyeY  = repeat(0,100)

integer pal pal = 1
-- ** Background colours 1 to 8 (0 to 7)
for r = 0 to 1 do
  for g = 0 to 1 do
    for b = 0 to 1 do
      Palette[pal] = {r * 63,g * 63,b * 63}
      pal = pal + 1
    end for
  end for
end for
-- ** Ship colours - 9 to 16 (8 to 15)
for r = 0 to 1 do
  for g = 0 to 1 do
    for b = 0 to 1 do
      Palette[pal] = {r * 63,g * 63,b * 63}
      pal = pal + 1
    end for
  end for
end for
-- Sprite colours - 17 to 256 (16 to 255)
pal = 17
for a = 16 to 255 by 4 do
  Palette[pal] = {40,00,00} pal = pal + 1
  Palette[pal] = {00,40,00} pal = pal + 1
  Palette[pal] = {00,00,40} pal = pal + 1
  Palette[pal] = {63,63,63} pal = pal + 1
end for

-- Colour scheme :-
--  00 to 07 = Background
--  08 to 15 = Ship (Only colour 15 is used)
--  16 to 19 = Sprite #1
--  20 to 23 = Sprite #2
--  24 to 27 = Sprite #3
--  28 to 31 = Sprite #4 etc, etc
-- Giving each sprite its own range of pixels makes it much easier to work out
-- which one got hit

ExplosionColours = {7,6,5,4,3,2,1}

Shape = {0,0,0,0}

-- Colour 0 remains as is
-- Colours 1,2 & 3 get re-mapped by "InstallSprite()"

-- Format Y-offset, Left-Offset, Pixel data

--       7 6 5 4 3 2 1 |
Shape[1] = {
  {-4,3,         0,0,0,0,0,0,0},
  {-3,5,     0,0,0,0,1,1,1,0,0,0,0},
  {-2,6,   0,0,0,1,1,1,1,1,1,1,0,0,0},
  {-1,6,   0,0,1,1,1,1,1,1,1,1,1,0,0},
  { 0,6,   0,0,1,1,1,1,1,1,1,1,1,0,0},
  { 1,6,   0,0,1,1,1,1,1,1,1,1,1,0,0},
  { 2,6,   0,0,0,1,1,1,1,1,1,1,0,0,0},
  { 3,5,     0,0,0,0,1,1,1,0,0,0,0},
  { 4,4,       0,0,0,0,0,0,0,0,0} }

--       7 6 5 4 3 2 1 |
Shape[2] = {
  {-6,2,           0,0,0,0,0},
  {-5,6,   0,0,0,0,0,0,2,0,0,0,0,0,0},
  {-4,7, 0,0,0,0,0,0,2,2,2,0,0,0,0,0,0},
  {-3,7, 0,0,2,2,2,2,2,2,2,2,2,2,2,0,0},
  {-2,7, 0,0,2,2,2,2,2,2,2,2,2,2,2,0,0},
  {-1,7, 0,0,0,2,2,2,2,2,2,2,2,2,0,0,0},
  { 0,7, 0,0,0,2,2,2,2,2,2,2,2,2,0,0,0},
  { 1,7, 0,0,2,2,2,2,2,2,2,2,2,2,2,0,0},
  { 2,7, 0,0,0,2,2,2,2,2,2,2,2,2,0,0,0},
  { 3,6,   0,0,0,0,0,2,2,2,0,0,0,0,0},
  { 4,4,       0,0,0,0,0,0,0,0,0} }

--       7 6 5 4 3 2 1 |
Shape[3] = {
  {-5,4,       0,0,0,0,0,0,0,0,0},
  {-4,6,   0,0,0,0,3,0,0,0,3,0,0,0,0},
  {-3,6,   0,0,3,3,3,3,3,3,3,3,3,0,0},
  {-2,7, 0,0,0,3,1,1,1,1,1,1,1,3,0,0,0},
  {-1,7, 0,0,3,3,1,1,1,1,1,1,1,3,3,0,0},
  { 0,7, 0,0,3,3,1,1,1,1,1,1,1,3,3,0,0},
  { 1,7, 0,0,3,3,3,3,3,3,3,3,3,3,3,0,0},
  { 2,6,   0,0,0,0,3,3,3,3,3,0,0,0,0},
  { 3,3,         0,0,0,3,0,0,0},
  { 4,3,         0,0,0,0,0,0,0} }


global procedure UpdateInvader(integer id)
  integer st,fx,fy,cc,fe,x,y,tf
  atom xd,yd,yo,xi,yi
  st = SpriteType[id]
  if st > 0 then -- Invader is alive
    x = SpriteX[id] -- Get co-ords
    y = SpriteY[id]
    -- ** Handle movements **
    if SpritesAdvance > 0 then -- Advance and shoot
      tf = GroupFear + SpriteFear[id] -- Total fear
      if tf >= 1000 then -- FEAR ! - Move away sideways
	SpriteX[id] = MoveAwayX(x,ShipX,2)
	if tf >= 5000 then -- PANIC ! - Move away upwards
	  SpriteY[id] = MoveAwayY(y,ShipY,1)
	else -- Move down on planed course
	  SpriteY[id] = MoveTo(y,ShipY,1)
	end if
      else -- Stay on planed course
	SpriteX[id] = MoveTo(x,SpriteXd[id],2)
	SpriteY[id] = MoveTo(y,SpriteYd[id],1)
      end if
      -- ** Handle targeting
      if y >= FiringLine then
	xd = floor((ShipX - x + 16) / 32) -- Approximation
	yd = floor((ShipY - y + 16) / 32)
	if xd = 0 then -- Shoot down at human vermin !
	  xi = ((rand(11) - 5) / 10)
	  yi = 4
	  NewMissile(x,y + 5,xi,yi,7)
	elsif yd = 0 then -- Shoot across at human to end game
	  if rand(10) = 1 then -- Leave gap between shots
	    xi = Sign(ShipX - x) * 4
	    yi = 0
	    NewMissile(x + xi+ xi,GfxBot - rand(5) + 1,xi,yi,2)
	  end if
	elsif Abs(xd) = yd then -- Shoot down at 45 degrees
	  xi = Sign(ShipX - x) * 3 + (rand(10) / 20)
	  yi = 3
	  NewMissile(x,y + 5,xi,yi,6)
	end if
      end if
    end if
    -- ** Handle facial expressions **
    fe = rand(10) -- Choose a facial expression
    if fe > 1 then -- Un-blink
      if Attention > 0 then -- Look at something
	if AttentionX > x then InvaderEyeX[id] = 1  end if
	if AttentionX < x then InvaderEyeX[id] = -1 end if
	if AttentionY > y then InvaderEyeY[id] = 1  end if
	if AttentionY < y then InvaderEyeY[id] = -1 end if
      else -- Lose interest, look ahead
	InvaderEyeX[id] = rand(3) - 2
	InvaderEyeY[id] = rand(3) - 2
      end if
      fx = x + InvaderEyeX[id]
      fy = y + InvaderEyeY[id]
      cc = 19 + ((id - 1) * 4)
      draw_line(cc,{{fx - 2,fy - 1},{fx - 1,fy - 1}})
      draw_line(cc,{{fx + 2,fy - 1},{fx + 1,fy - 1}})
    end if
  end if
end procedure

global procedure DrawShip(integer sc)
  integer x1,x2,y1,y2,y3,y4,y5
  x1 = ShipLx
  x2 = ShipX
  y1 = ShipY
  y2 = y1 - 1
  y3 = y2 - 1
  y4 = y3 - 1
  y5 = y4 - 1
  
  draw_line(0,{{x1 - 10,y1},{x1 + 10,y1}})
  draw_line(0,{{x1 - 10,y2},{x1 + 10,y2}})
  draw_line(0,{{x1 - 10,y3},{x1 + 10,y3}})
  draw_line(0,{{x1 - 8,y4},{x1 + 8,y4}})
  draw_line(0,{{x1 - 3,y5},{x1 + 3,y5}})
  
  draw_line(sc,{{x2 - 8,y1},{x2 + 8,y1}})
  draw_line(sc,{{x2 - 8,y2},{x2 + 8,y2}})
  draw_line(sc,{{x2 - 8,y3},{x2 + 8,y3}})
  draw_line(sc,{{x2 - 6,y4},{x2 + 6,y4}})
  draw_line(sc,{{x2 - 1,y5},{x2 + 1,y5}})
  ShipLx = ShipX
end procedure

global procedure NewInvaders()
  integer ShapeID
  Sprite = 0
  for InvY = 0 to 3 do
    for InvX = 0 to 7 do
      Sprite = Sprite + 1
      SpriteX[Sprite] = 20 + (InvX * 40)
      SpriteY[Sprite] = 20 + (InvY * 15) + (Wave * 4)
      SpriteXd[Sprite] = 20 + (InvX * 40)
      SpriteYd[Sprite] = GfxBot - 3
      ShapeID = rand(3) -- Choose one of three shapes
      SpriteType[Sprite] = ShapeID
      SpriteShape[Sprite] = InstallSprite(Sprite,Shape[ShapeID])
      SpriteFear[Sprite] = (rand(100) * rand(10))
      UpdateSprite(Sprite)
    end for
  end for
  Sprites = Sprite
  Sprite = 1
end procedure

