-- Ŀ
--  Space Invaders - The Next Generation - V1.04 (C) 1996 PJB Systems   Main 
-- 

without warning
without type_check

include si-tng-1.e
include si-tng-2.e
include get.e

integer key,tmp
atom    FramePeriod,NextFramePeriod

global integer Cycle      Cycle = 0 -- Slow cycle counter

if iSbCardError = 0 then -- Load .WAVs if SB Card is OK
  SoundEffects = LoadSoundEffects({"Phaser.WAV","Explode.WAV","Ricochet.WAV" })
else
  printf(1,"SB Card Error %d %s\n",{iSbCardError,ERROR_MESSAGES[iSbCardError]})
  puts(1,"The game will play without sound\n")
  puts(1,"Press any key\n")
  tmp = wait_key()
end if


tmp = graphics_mode(19) -- 320 x 200 x 256
all_palette(Palette) -- Set earlier in SI-TNG-2.E

key = 0
ParticleTrail = 0 -- 0 = Black, 1 = Blue ...
ParticleCount = 50 -- Make smaller for 386, larger for Pentium
ParticleRadius = 10 -- Likewise..
ParticleGravity = 0.1 -- 0 = None
ParticleYBias = 0 -- Try 0.0 to 1.0
GfxTop = 8

ShipX = 160 -- Halfway across screen
ShipY = GfxBot -- At bottom of screen
ShipShield = 10
DrawShip(14)
Sprite = 1 -- Current sprite
Sprites = 0 -- Max sprites
Wave = 0 -- Current attack wave
LaserMaxChg = 200 -- Laser max charge, if this game is too hard make it 1000 !
LaserCharge = LaserMaxChg

-- ** GAME LOOP **
NextFramePeriod = 0.04
while (key != 27) and (ShipShield > 0) do -- Until ESC or no shield
  FramePeriod = time() + NextFramePeriod -- Set frame period
  key = peek(#417) -- Ctrl, Alt & Shift codes from BIOS
  if key >= 128 then key = key - 128 end if -- Strip bit 7
  if key >= 64  then key = key - 64  end if -- Strip bit 6
  if key >= 32  then key = key - 32  end if -- Strip bit 5
  if key >= 16  then key = key - 16  end if -- Strip bit 4
  if key >= 8 then -- Move ship right (Left-ALT)
    key = key - 8 -- Strip bit 3
    if ShipX < 310 then
      ShipX = ShipLx + 2
    end if
  end if
  if key >= 4 then -- Move ship left (Left CTRL)
    key = key - 4 -- Strip bit 2
    if ShipX > 10 then
      ShipX = ShipLx - 2
    end if
  end if
  if key >= 2 then -- Fire Anti-matter spread (Left SHIFT)
    key = key - 2 -- Strip bit 1
    if LaserCharge >= 50 then
      LaserCharge = LaserCharge - 50
      for lx = - 3 to 3 do
	NewMissile(ShipX,GfxBot - 4,lx,-4, 3)
      end for
      AttentionX = ShipX -- Look at ship..
      AttentionY = 200 -- ...for a...
      Attention = 100 -- ...while
      SpritesAdvance = 1 -- Advance & kill human vermin ! :-)
    end if
  end if
  if key > 0 then -- Fire phaser (Right SHIFT)
    if LaserCharge >= 10 then -- Enough to fire
      LaserCharge = LaserCharge - 10
      NewMissile(ShipX,GfxBot - 4 - rand(3), 0,-4,5)
      AttentionX = ShipX
      AttentionY = GfxBot
      Attention = 100
      SpritesAdvance = 1
    end if
  end if
  
  if ShipX != ShipLx then -- Move ship to new co-ords
    DrawShip(15)
    AttentionX = ShipX
    AttentionY = 200
    Attention = 25
  end if
  
  while SpriteType[Sprite] = 0 do -- Find next one alive to move
    Sprite = Sprite + 1
    if Sprite > Sprites then -- At end of list
      Sprite = 1 -- Start from 1...
      exit -- .. and leave (to prevent infinate loops !)
    end if
  end while
  
  UpdateSprite(Sprite)
  UpdateInvader(Sprite)
  UpdateExplosions()
  UpdateMissiles()
  HouseKeeping(Sprite)
  
  Sprite = Sprite + 1
  if Sprite > Sprites then Sprite = 1 end if
    
  if Cycle < 1 then -- Do SLOW loop
    Cycle = 10 -- Reset loop counter
    if SpritesActive = 0 then -- New wave
      if (ParticleMax + MissileMax) = 0 then -- Wait for "bits" to stop
	clear_screen()
	NewInvaders()
	GroupFear = Wave * 50 -- Each wave is more frightened
	Wave = Wave + 1
	ShipShield = ShipShield + 1
	SpritesAdvance = 0
      end if
    end if
    position(1,2)
    text_color(6)
    printf(1,"Wave %d Score %d Shield %d Laser %d ",
      {Wave,Score,ShipShield,LaserCharge})
    DrawShip(15)
  else -- Don't do loop this time around
    Cycle = Cycle - 1
  end if
  
  key = get_key() -- Scan for ESC
  
  while time() < FramePeriod do -- Wait for 1/18 second
  end while
end while

-- ** END OF GAME LOOP *
position(1,2)
text_color(4)
printf(1,"Wave %d Score %d Shield %d Laser %d ",
  {Wave,Score,ShipShield,LaserCharge})
for i = 1 to Sprites do
  UpdateSprite(i)
  UpdateInvader(i)
end for
ParticleYBias = -2 -- Explode upwards !
NewExplosion(ShipX,ShipY,250,50,2) -- Nice big explosion for ship !
while ParticleMax > 0 do -- Wait until all explosions have died
  FramePeriod = time() + NextFramePeriod
  HouseKeeping(1)
  UpdateExplosions()
  UpdateMissiles()
  
  text_color(rand(7))
  position(11,16)
  puts(1,"GAME OVER")
  
  while time() < FramePeriod do -- Wait for 1/18 second
  end while
end while
text_color(7)
position(12,14)
puts(1,"Press any key\n")
position(14,3)
puts(1,"Space Invaders - The Next Generation\n")
position(16,3)
puts(1,"Peter Blue 101363.445@CompuServe.com\n")

tmp = wait_key()
tmp = graphics_mode(-1)


