-- sound effect for game using sound blaster card.
-- by Jacques Deschenes, Baie-Comeau, PQ, Canada, e-mail: desja@quebectel.com
-- creation date: Nov 2th, 1996

include file.e
include sbcard.e
include doswrap.e

-----------------------------------------------------------------------------


global function LoadSoundEffects(sequence Files)

integer FHandle, DataOfs, junk
 
sequence WaveInfo, AllBuffers, SoundInfo

   AllBuffers = repeat({},length(Files))

   SoundInfo = repeat(0,4)

   clear_screen()

   puts(1,"Loading sound files:\n")

   for  i = 1 to length(Files)  do  -- load files loop

      FHandle = open(Files[i],"rb")

      puts(1,Files[i]&"\n")

      WaveInfo = GetWavInfo(FHandle)
      
      DataOfs = where(FHandle)
      
      close(FHandle)
      
      
      SoundInfo[2] = WaveInfo[siDATA_LEN]

      if SoundInfo[2] > 65536 then

	SoundInfo[2] = 65536 -- max buffer size

      end if

      SoundInfo[1] = AllocateDMABuffer(SoundInfo[2])-- allocate buffer needed size

      if SoundInfo[1] > 0 then  -- load only if buffer allocated.

	FHandle = DosOpen(Files[i],READ)
      
	if DosSeek(FHandle,DataOfs,0) then
	   
	   SoundInfo[2] = BlockRead(FHandle,SoundInfo[1],SoundInfo[2])
	
	end if

      end if
      
      junk = DosClose(FHandle)
      
      SoundInfo[3] = ComputeTC(WaveInfo[siSPS],WaveInfo[siCHANNELS])

      SoundInfo[4] = WaveInfo[siCHANNELS]

      close(FHandle)

      AllBuffers[i] = SoundInfo

   end for 

    return AllBuffers
    
end function -- LoadSoundEffects()




-------------------------------------------------------------------------------

global procedure PlaySoundEffect(sequence SoundEffect)
-- play only 8 bits wave data
  if not BufferDone() then  -- if a sound  already playing

     if not ResetDSP() then  -- stop it by resetting sound blaster
       
       return

     end if

    SetVolume(MASTER_VOLUME,VOL_MAX)

    SetVolume(VOICE_VOLUME,4)

    SpeakerOn()

  end if

  SetChannels(SoundEffect[4]) -- set number of channels mono or stereo

  PlayBuffer(SoundEffect[1],  -- dma buffer address

	   SoundEffect[2],    -- data size

	   SoundEffect[3],    -- time constant

	   SoundEffect[4])    -- number of channels

end procedure -- PlaySoundEffect()

